Index: trunk/MagicSoft/Cosy/gui/MGSkyPosition.cc
===================================================================
--- trunk/MagicSoft/Cosy/gui/MGSkyPosition.cc	(revision 1760)
+++ trunk/MagicSoft/Cosy/gui/MGSkyPosition.cc	(revision 1784)
@@ -72,5 +72,5 @@
     {
         fStars[i] = new TArc(0, 0, 1);
-        InitArc(fStars[i], 1001, kWhite, kWhite);
+        InitArc(fStars[i], 1001, 17, 15);
         fList->Add(fStars[i]);
     }
@@ -104,29 +104,30 @@
 }
 
+static const RaDec stars[13] =
+{
+    // 32349   Sirius           -1.44 1.45    2.64      0.009   A0m
+    (RaDec(Slalib::Hms2Rad(  6, 45, 0), Slalib::Dms2Rad(-16, 42, 0))),
+    // 30438   Canopus          -0.62 -5.53   95.88     0.164   F0Ib
+    (RaDec(Slalib::Hms2Rad(  6, 23, 0), Slalib::Dms2Rad(-52, 41, 0))),
+    // 69673   Arcturus         -0.05 -0.31   11.25     1.239   K2IIIp
+    (RaDec(Slalib::Hms2Rad( 14, 15, 0), Slalib::Dms2Rad( 19, 10, 0))),
+    (RaDec(Slalib::Hms2Rad( 01, 37, 6), Slalib::Dms2Rad(-57, 14, 0))),
+    (RaDec(Slalib::Hms2Rad( 12, 26, 6), Slalib::Dms2Rad(-63, 06, 0))),
+    (RaDec(Slalib::Hms2Rad( 13, 25, 2), Slalib::Dms2Rad(-11, 10, 0))),
+    (RaDec(Slalib::Hms2Rad(  5, 14, 0), Slalib::Dms2Rad(- 8, 12, 5))),
+    (RaDec(Slalib::Hms2Rad( 19, 50, 0), Slalib::Dms2Rad(- 8, 52, 6))),
+    (RaDec(Slalib::Hms2Rad( 18, 37, 0), Slalib::Dms2Rad( 38, 47, 0))),
+    (RaDec(Slalib::Hms2Rad(  5, 16, 0), Slalib::Dms2Rad( 46, 00, 0))),
+    (RaDec(Slalib::Hms2Rad(  7, 39, 0), Slalib::Dms2Rad(  5, 14, 0))),
+    (RaDec(Slalib::Hms2Rad(  5, 55, 0), Slalib::Dms2Rad(  7, 24, 0))),
+    (RaDec(Slalib::Hms2Rad( 19, 50, 0), Slalib::Dms2Rad(  8, 52, 0)))
+};
+
 void MGSkyPosition::UpdateStars()
 {
-    RaDec stars[13];
-
-    // 32349   Sirius           -1.44 1.45    2.64      0.009   A0m
-    stars[0] = RaDec(MObservatory::Hms2Rad(  6, 45, 0), MObservatory::Dms2Rad(-16, 42, 0));
-    // 30438   Canopus          -0.62 -5.53   95.88     0.164   F0Ib
-    stars[1] = RaDec(MObservatory::Hms2Rad(  6, 23, 0), MObservatory::Dms2Rad(-52, 41, 0));
-    // 69673   Arcturus         -0.05 -0.31   11.25     1.239   K2IIIp
-    stars[2] = RaDec(MObservatory::Hms2Rad( 14, 15, 0), MObservatory::Dms2Rad( 19, 10, 0));
-    stars[3] = RaDec(MObservatory::Hms2Rad( 01, 37, 6), MObservatory::Dms2Rad(-57, 14, 0));
-    stars[4] = RaDec(MObservatory::Hms2Rad( 12, 26, 6), MObservatory::Dms2Rad(-63, 06, 0));
-    stars[5] = RaDec(MObservatory::Hms2Rad( 13, 25, 2), MObservatory::Dms2Rad(-11, 10, 0));
-    stars[6] = RaDec(MObservatory::Hms2Rad(  5, 14, 0), MObservatory::Dms2Rad(- 8, 12, 5));
-    stars[7] = RaDec(MObservatory::Hms2Rad( 19, 50, 0), MObservatory::Dms2Rad(- 8, 52, 6));
-    stars[8] = RaDec(MObservatory::Hms2Rad( 18, 37, 0), MObservatory::Dms2Rad( 38, 47, 0));
-    stars[9] = RaDec(MObservatory::Hms2Rad(  5, 16, 0), MObservatory::Dms2Rad( 46, 00, 0));
-    stars[10] = RaDec(MObservatory::Hms2Rad(  7, 39, 0), MObservatory::Dms2Rad(  5, 14, 0));
-    stars[11] = RaDec(MObservatory::Hms2Rad(  5, 55, 0), MObservatory::Dms2Rad(  7, 24, 0));
-    stars[12] = RaDec(MObservatory::Hms2Rad( 19, 50, 0), MObservatory::Dms2Rad(  8, 52, 0));
-
     for (int i=0; i<13; i++)
         SetDot(fStars[i], stars[i], 0);
-
-}
+}
+
 void MGSkyPosition::InitText()
 {
@@ -244,5 +245,5 @@
 }
 
-void MGSkyPosition::SetDot(TArc *arc, RaDec &radec, Int_t off)
+void MGSkyPosition::SetDot(TArc *arc, const RaDec &radec, Int_t off)
 {
     RaDec rd(radec.Ra()+off*360/24*kDeg2Rad, radec.Dec());
@@ -258,5 +259,5 @@
     arc->SetY1(y);
 
-    SetModified();
+    //SetModified(); ***MEMORY LEAK!!!***
 }
 
Index: trunk/MagicSoft/Cosy/gui/MGSkyPosition.h
===================================================================
--- trunk/MagicSoft/Cosy/gui/MGSkyPosition.h	(revision 1760)
+++ trunk/MagicSoft/Cosy/gui/MGSkyPosition.h	(revision 1784)
@@ -67,5 +67,5 @@
     void SetLin2(Float_t x1, Float_t y1, Float_t x2, Float_t y2);
 
-    void SetDot(TArc *arc, RaDec &radec, Int_t off);
+    void SetDot(TArc *arc, const RaDec &radec, Int_t off);
 
     void UpdateStars();